## uClibc-0.9.11.tar.bz2

=== Makefile ===
# Makefile for uClibc
#
# Copyright (C) 2000 by Lineo, inc.
# Copyright (C) 2000,2001,2002 Erik Andersen <andersen@uclibc.org>
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU Library General Public License as published by the Free
# Software Foundation; either version 2 of the License, or (at your option) any
# later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE. See the GNU Library General Public License for more
# details.
#
# You should have received a copy of the GNU Library General Public License
# along with this program; if not, write to the Free Software Foundation, Inc.,
# 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
# Makefile for uClibc
#
# Derived in part from the Linux-8086 C library, the GNU C Library, and several
# other sundry sources.  Files within this library are copyright by their
# respective copyright holders.

#--------------------------------------------------------
#
#There are a number of configurable options in "Config"
#
#--------------------------------------------------------

TOPDIR=./
include Rules.mak

DIRS = extra ldso libc libcrypt libresolv libutil libm libpthread

all: headers uClibc_config subdirs shared util finished

Config:
	@echo
	@echo "You didn't read the README, did you... =)"
	@echo "Choose a configuration file in extras/Config/ and then run"
	@echo "  ln -s ./extra/Configs/Config.<arch> ./Config"
	@echo
	@exit 1

shared:
ifeq ($(strip $(HAVE_SHARED)),true)
	@$(MAKE) -C libc shared
	@$(MAKE) -C ldso shared
	@$(MAKE) -C libcrypt shared
	@$(MAKE) -C libresolv shared
	@$(MAKE) -C libutil shared
	@$(MAKE) -C libm shared
	@$(MAKE) -C libpthread shared
else
	@echo
	@echo Not building shared libraries...
	@echo
endif

util:
ifeq ($(strip $(HAVE_SHARED)),true)
	@$(MAKE) -C ldso utils
endif

finished: shared
	@echo
	@echo Finally finished compiling...
	@echo

headers: dummy
	rm -f include/asm;
	@if [ $(TARGET_ARCH) = "powerpc" ];then \
	    ln -fs $(KERNEL_SOURCE)/include/asm-ppc include/asm; \
	elif [ $(TARGET_ARCH) = "v850" ];then \
	    ln -fs $(KERNEL_SOURCE)/include/asm-v850 include/asm; \
	elif [ $(TARGET_ARCH) = "mips" ];then \
	    ln -fs $(KERNEL_SOURCE)/include/asm-mips include/asm; \
	elif [ $(TARGET_ARCH) = "mipsel" ];then \
	    ln -fs $(KERNEL_SOURCE)/include/asm-mips include/asm; \
	    cd $(PWD)/libc/sysdeps/linux; \
	    ln -fs mips mipsel; \
	    cd $(PWD)/ldso/ldso; \
	    ln -fs mips mipsel; \
	    cd $(PWD)/libpthread/linuxthreads/sysdeps; \
	    ln -fs mips mipsel; \
	elif [ $(TARGET_ARCH) = "h8300" ];then \
	    ln -fs $(KERNEL_SOURCE)/include/asm-h8300 include/asm; \
	else \
	    if [ $(HAS_MMU) != "true" ]; then \
			ln -fs $(KERNEL_SOURCE)/include/asm-$(TARGET_ARCH)nommu include/asm;\
		else \
			ln -fs $(KERNEL_SOURCE)/include/asm-$(TARGET_ARCH) include/asm; \
		fi; \
	fi;
	@if [ ! -f include/asm/unistd.h ] ; then \
	    set -e; \
	    echo " "; \
	    echo "The path '$(KERNEL_SOURCE)/include/asm' doesn't exist."; \
	    echo "I bet you didn't set KERNEL_SOURCE, TARGET_ARCH or HAS_MMU in \`Config'"; \
	    echo "correctly.  Please edit \`Config' and fix these settings."; \
	    echo " "; \
	    /bin/false; \
	fi;
	@if [ $(HAS_MMU) != "true" -a $(TARGET_ARCH) = "i386" ] ; then \
	    set -e; \
	    echo "WARNING: I bet your x86 system really has an MMU, right?"; \
	    echo "         malloc and friends won't work unless you fix \`Config'"; \
	    echo " "; \
	    sleep 10; \
	fi;
	rm -f include/linux
	ln -fs $(KERNEL_SOURCE)/include/linux include/linux
	rm -rf include/bits
	mkdir -p include/bits
	@cd include/bits; \
	set -e; \
	for i in `ls ../../libc/sysdeps/linux/common/bits/*.h` ; do \
		ln -fs $$i .; \
	done; \
	if [ -d ../../libc/sysdeps/linux/$(TARGET_ARCH)/bits ] ; then \
		for i in `ls ../../libc/sysdeps/linux/$(TARGET_ARCH)/bits/*.h` ; do \
			ln -fs $$i .; \
		done; \
	fi
	@cd include/sys; \
	set -e; \
	for i in `ls ../../libc/sysdeps/linux/common/sys/*.h` ; do \
		ln -fs $$i .; \
	done; \
	if [ -d ../../libc/sysdeps/linux/$(TARGET_ARCH)/sys ] ; then \
		for i in `ls ../../libc/sysdeps/linux/$(TARGET_ARCH)/sys/*.h` ; do \
			ln -fs $$i .; \
		done; \
	fi
	@cd $(TOPDIR); \
	set -x -e; \
	rm -f include/bits/syscall.h; \
	TOPDIR=$(TOPDIR) CC=$(CC) /bin/sh $(TOPDIR)/extra/scripts/gen_bits_syscall_h.sh > include/bits/syscall.h
	$(MAKE) -C libc/sysdeps/linux/$(TARGET_ARCH) headers

uClibc_config: Makefile Config
	@echo "/* WARNING!!! AUTO-GENERATED FILE!!! DO NOT EDIT!!! */" > include/bits/uClibc_config.h
	@echo "#if !defined __FEATURES_H && !defined __need_uClibc_config_h" >> include/bits/uClibc_config.h
	@echo "#error Never include <bits/uClibc_config.h> directly; use <features.h> instead." >> include/bits/uClibc_config.h
	@echo "#endif" >> include/bits/uClibc_config.h
	@echo "#define linux 1" >> include/bits/uClibc_config.h 
	@echo "#define __linux__ 1" >> include/bits/uClibc_config.h 
	@if [ "$(INCLUDE_IPV6)" = "true" ] ; then \
	    echo "#define __UCLIBC_HAS_IPV6__ 1" >> include/bits/uClibc_config.h ; \
	else \
	    echo "#undef __UCLIBC_HAS_IPV6__" >> include/bits/uClibc_config.h ; \
	fi
	@if [ "$(HAS_MMU)" = "true" ] ; then \
	    echo "#define __UCLIBC_HAS_MMU__ 1" >> include/bits/uClibc_config.h ; \
	else \
	    echo "#undef __UCLIBC_HAS_MMU__" >> include/bits/uClibc_config.h ; \
	fi
	@if [ "$(HAS_FLOATING_POINT)" = "true" ] ; then \
	    echo "#define __UCLIBC_HAS_FLOATS__ 1" >> include/bits/uClibc_config.h ; \
	else \
	    echo "#undef __UCLIBC_HAS_FLOATS__" >> include/bits/uClibc_config.h ; \
	fi
	@if [ "$(HAS_LONG_LONG)" = "true" ] ; then \
	    echo "#define __UCLIBC_HAS_LONG_LONG__ 1" >> include/bits/uClibc_config.h ; \
	else \
	    echo "#undef __UCLIBC_HAS_LONG_LONG__" >> include/bits/uClibc_config.h ; \
	fi
	@if [ "$(HAS_LOCALE)" = "true" ] ; then \
	    echo "#define __UCLIBC_HAS_LOCALE__ 1" >> include/bits/uClibc_config.h ; \
	    echo "#define __UCLIBC_LOCALE_DIR \""$(LOCALE_DIR)"\"" >> include/bits/uClibc_config.h ; \
	else \
	    echo "#undef __UCLIBC_HAS_LOCALE__" >> include/bits/uClibc_config.h ; \
	fi
	@if [ "$(HAVE_ELF)" = "false" ] ; then \
	    echo "#undef HAVE_ELF" >> include/bits/uClibc_config.h ; \
	else \
	    echo "#define HAVE_ELF 1" >> include/bits/uClibc_config.h ; \
	fi
	@if [ "$(HAVE_SHARED)" = "false" ] ; then \
	    echo "#undef HAVE_SHARED" >> include/bits/uClibc_config.h ; \
	else \
	    echo "#define HAVE_SHARED 1" >> include/bits/uClibc_config.h ; \
	fi
	@if [ "$(TARGET_ARCH)" = "sh" ] ; then \
	    echo "#define NO_UNDERSCORES 1" >> include/bits/uClibc_config.h ; \
	else \
	    echo "#undef NO_UNDERSCORES" >> include/bits/uClibc_config.h ; \
	fi
	@if [ "$(INCLUDE_RPC)" = "true" ] ; then \
	    echo "#define __UCLIBC_HAS_RPC__ 1" >> include/bits/uClibc_config.h ; \
	else \
	    echo "#undef __UCLIBC_HAS_RPC__" >> include/bits/uClibc_config.h ; \
	fi
	@if [ "$(UNIFIED_SYSCALL)" = "true" ] ; then \
	    echo "#define __UCLIBC_USE_UNIFIED_SYSCALL__ 1" >> include/bits/uClibc_config.h ; \
	else \
	    echo "#undef __UCLIBC_USE_UNIFIED_SYSCALL__" >> include/bits/uClibc_config.h ; \
	fi
	@echo "#define C_SYMBOL_PREFIX "\""$(C_SYMBOL_PREFIX)"\" >> include/bits/uClibc_config.h
	@if [ "$(DOLFS)" = "true" ] ; then \
	    echo "#define __UCLIBC_HAVE_LFS__ 1" >> include/bits/uClibc_config.h ; \
	else \
	    echo "#undef __UCLIBC_HAVE_LFS__" >> include/bits/uClibc_config.h ; \
	fi
	@if [ "$(INCLUDE_THREADS)" = "true" ] ; then \
	    echo "#define __UCLIBC_HAS_THREADS__ 1" >> include/bits/uClibc_config.h ; \
	else \
	    echo "#undef __UCLIBC_HAS_THREADS__" >> include/bits/uClibc_config.h ; \
	fi
	@if [ "$(INCLUDE_REGEX)" = "true" ] ; then \
	    echo "#define __UCLIBC_HAS_REGEX__ 1" >> include/bits/uClibc_config.h ; \
	else \
	    echo "#undef __UCLIBC_HAS_REGEX__" >> include/bits/uClibc_config.h ; \
	fi
	@if [ "$(UNIX98PTY_ONLY)" = "true" ] ; then \
	    echo "#define UNIX98PTY_ONLY 1" >> include/bits/uClibc_config.h ; \
	else \
	    echo "#undef UNIX98PTY_ONLY" >> include/bits/uClibc_config.h ; \
	fi
	@if [ "$(ASSUME_DEVPTS)" = "true" ] ; then \
	    echo "#define ASSUME_DEVPTS 1" >> include/bits/uClibc_config.h ; \
	else \
	    echo "#undef ASSUME_DEVPTS" >> include/bits/uClibc_config.h ; \
	fi

subdirs: $(patsubst %, _dir_%, $(DIRS))

$(patsubst %, _dir_%, $(DIRS)) : dummy
	$(MAKE) -C $(patsubst _dir_%, %, $@)

tags:
	ctags -R

install: install_dev install_runtime install_toolchain install_utils finished2


# Installs header files and development library links.
install_dev:
	install -d $(PREFIX)$(DEVEL_PREFIX)/lib
	install -d $(PREFIX)$(DEVEL_PREFIX)/usr/lib
	install -d $(PREFIX)$(DEVEL_PREFIX)/include
	-install -m 644 lib/*.[ao] $(PREFIX)$(DEVEL_PREFIX)/lib/
	tar -chf - include | tar -xf - -C $(PREFIX)$(DEVEL_PREFIX);
	-@for i in `find  $(PREFIX)$(DEVEL_PREFIX) -type d` ; do \
	    chmod -f 755 $$i; chmod -f 644 $$i/*.h; \
	done;
	-find $(PREFIX)$(DEVEL_PREFIX) -name CVS | xargs rm -rf;
	-chown -R `id | sed 's/^uid=\([0-9]*\).*gid=\([0-9]*\).*$$/\1.\2/'` $(PREFIX)$(DEVEL_PREFIX)
ifeq ($(strip $(HAVE_SHARED)),true)
	-find lib/ -type l -name '*.so' -exec cp -a {} $(PREFIX)$(DEVEL_PREFIX)/lib ';'
endif


# Installs run-time libraries and helper apps onto the host system
# allowing cross development.  If you want to deploy to a target 
# system, use the "install_target" target instead... 
install_runtime:
ifeq ($(strip $(HAVE_SHARED)),true)
	install -d $(PREFIX)$(DEVEL_PREFIX)/lib
	install -d $(PREFIX)$(DEVEL_PREFIX)/bin
	install -m 644 lib/lib*-$(MAJOR_VERSION).$(MINOR_VERSION).so $(PREFIX)$(DEVEL_PREFIX)/lib
	cp -a lib/*.so.* $(PREFIX)$(DEVEL_PREFIX)/lib
	@if [ -x lib/ld-uClibc-$(MAJOR_VERSION).$(MINOR_VERSION).so ] ; then \
	    set -x -e; \
	    install -m 755 lib/ld-uClibc-$(MAJOR_VERSION).$(MINOR_VERSION).so $(PREFIX)$(DEVEL_PREFIX)/lib; \
	    mkdir -p $(PREFIX)$(SHARED_LIB_LOADER_PATH); \
	    ln -s $(DEVEL_PREFIX)/lib/ld-uClibc-$(MAJOR_VERSION).$(MINOR_VERSION).so \
			$(PREFIX)$(SHARED_LIB_LOADER_PATH)/$(UCLIBC_LDSO) || true; \
	fi;
endif

install_toolchain:
	install -d $(PREFIX)$(DEVEL_PREFIX)/lib
	install -d $(PREFIX)$(DEVEL_PREFIX)/bin
	install -d $(PREFIX)$(SYSTEM_DEVEL_PREFIX)/bin
	$(MAKE) -C extra/gcc-uClibc install

install_utils:
ifeq ($(strip $(HAVE_SHARED)),true)
	@$(MAKE) -C ldso utils
	install -m 755 ldso/util/ldd $(PREFIX)$(DEVEL_PREFIX)/bin
	ln -fs $(DEVEL_PREFIX)/bin/ldd $(PREFIX)$(SYSTEM_DEVEL_PREFIX)/bin/$(TARGET_ARCH)-uclibc-ldd
	# For now, don't bother with readelf since surely the host
	# system has binutils, or we couldn't have gotten this far...
	#install -m 755 ldso/util/readelf $(PREFIX)$(DEVEL_PREFIX)/bin
	#ln -fs $(DEVEL_PREFIX)/bin/readelf $(PREFIX)$(SYSTEM_DEVEL_PREFIX)/bin/$(TARGET_ARCH)-uclibc-readelf
	@if [ -x ldso/util/ldconfig ] ; then \
	    set -x -e; \
	    install -d $(PREFIX)$(DEVEL_PREFIX)/etc; \
	    install -m 755 ldso/util/ldconfig $(PREFIX)$(DEVEL_PREFIX)/bin; \
	    ln -fs $(DEVEL_PREFIX)/sbin/ldconfig $(PREFIX)$(SYSTEM_DEVEL_PREFIX)/bin/$(TARGET_ARCH)-uclibc-ldconfig; \
	fi;
endif

# Installs run-time libraries and helper apps in preparation for
# deploying onto a target system, but installed below wherever
# $PREFIX is set to, allowing you to package up the result for
# deployment onto your target system.
install_target:
ifeq ($(strip $(HAVE_SHARED)),true)
	install -d $(PREFIX)$(TARGET_PREFIX)/lib
	install -d $(PREFIX)$(TARGET_PREFIX)/sbin
	install -d $(PREFIX)$(TARGET_PREFIX)/usr/bin
	install -m 644 lib/lib*-$(MAJOR_VERSION).$(MINOR_VERSION).so $(PREFIX)$(TARGET_PREFIX)/lib
	cp -a lib/*.so.* $(PREFIX)$(TARGET_PREFIX)/lib
	@if [ -x lib/ld-uClibc-$(MAJOR_VERSION).$(MINOR_VERSION).so ] ; then \
	    set -x -e; \
	    install -m 755 lib/ld-uClibc-$(MAJOR_VERSION).$(MINOR_VERSION).so $(PREFIX)$(TARGET_PREFIX)/lib; \
	    mkdir -p $(PREFIX)$(SHARED_LIB_LOADER_PATH); \

=== ldso/Makefile ===
# Makefile for uClibc
#
# Copyright (C) 2000,2001 Erik Andersen <andersen@uclibc.org>
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU Library General Public License as published by the Free
# Software Foundation; either version 2 of the License, or (at your option) any
# later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE. See the GNU Library General Public License for more
# details.
#
# You should have received a copy of the GNU Library General Public License
# along with this program; if not, write to the Free Software Foundation, Inc.,
# 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
# Derived in part from the Linux-8086 C library, the GNU C Library, and several
# other sundry sources.  Files within this library are copyright by their
# respective copyright holders.

TOPDIR=../
include $(TOPDIR)Rules.mak

ALL_SUBDIRS = ldso libdl util


all:
ifeq ($(strip $(BUILD_UCLIBC_LDSO)),true)
	$(MAKE) -C $(LIBRARY_CACHE) ldso;
else
	echo "Not building ld-uClibc"
endif

shared:
ifeq ($(strip $(BUILD_UCLIBC_LDSO)),true)
	$(MAKE) -C $(LIBRARY_CACHE) libdl;
else
	echo "Not building libdl"
endif

utils:
	$(MAKE) -C $(LIBRARY_CACHE) util;

clean:
	set -e ; for d in $(ALL_SUBDIRS) ; do $(MAKE) -C $$d $@ ; done
	-find . -name '*~' | xargs rm -f

=== libcrypt/Makefile ===
# Makefile for uClibc
#
# Copyright (C) 2000 by Lineo, inc.
# Copyright (C) 2000,2001 Erik Andersen <andersen@uclibc.org>
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU Library General Public License as published by the Free
# Software Foundation; either version 2 of the License, or (at your option) any
# later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE. See the GNU Library General Public License for more
# details.
#
# You should have received a copy of the GNU Library General Public License
# along with this program; if not, write to the Free Software Foundation, Inc.,
# 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
# Derived in part from the Linux-8086 C library, the GNU C Library, and several
# other sundry sources.  Files within this library are copyright by their
# respective copyright holders.

TOPDIR=../
include $(TOPDIR)Rules.mak

LIBCRYPT=libcrypt.a
LIBCRYPT_SHARED=libcrypt.so
LIBCRYPT_SHARED_FULLNAME=libcrypt-$(MAJOR_VERSION).$(MINOR_VERSION).so

CSRC = crypt.c des.c
OBJS=$(patsubst %.c,%.o, $(CSRC))

all: $(OBJS) $(LIBCRYPT)

$(LIBCRYPT): ar-target

ar-target: $(OBJS)
	$(AR) $(ARFLAGS) $(LIBCRYPT) $(OBJS)
	install -d $(TOPDIR)lib
	rm -f $(TOPDIR)lib/$(LIBCRYPT)
	install -m 644 $(LIBCRYPT) $(TOPDIR)lib

$(OBJS): %.o : %.c
	$(CC) $(CFLAGS) -c $< -o $@
	$(STRIPTOOL) -x -R .note -R .comment $*.o

$(OBJ): Makefile

des.o: des.c md5.c

shared: all
	$(LD) $(LDFLAGS) -soname=$(LIBCRYPT_SHARED).$(MAJOR_VERSION) \
		-o $(LIBCRYPT_SHARED_FULLNAME) --whole-archive $(LIBCRYPT) \
		--no-whole-archive $(TOPDIR)/libc/misc/internals/interp.o \
		-L$(TOPDIR)/lib -lc;
	install -d $(TOPDIR)lib
	rm -f $(TOPDIR)lib/$(LIBCRYPT_SHARED_FULLNAME) $(TOPDIR)lib/$(LIBCRYPT_SHARED).$(MAJOR_VERSION)
	install -m 644 $(LIBCRYPT_SHARED_FULLNAME) $(TOPDIR)lib;
	(cd $(TOPDIR)lib && ln -sf $(LIBCRYPT_SHARED_FULLNAME) $(LIBCRYPT_SHARED)); 
	(cd $(TOPDIR)lib && ln -sf $(LIBCRYPT_SHARED_FULLNAME) $(LIBCRYPT_SHARED).$(MAJOR_VERSION)); 

clean: 
	rm -f *.[oa] *~ core $(LIBCRYPT_SHARED)* $(LIBCRYPT_SHARED_FULLNAME)*

=== libm/Makefile ===
# Makefile for uClibc's math library
#
# Copyright (C) 2000,2001 Erik Andersen <andersen@uclibc.org>
#
# The routines included in this math library are derived from the
# math library for Apple's MacOS X/Darwin math library, which was
# itself swiped from FreeBSD.  The original copyright information
# is as follows:
# 
#     Copyright (C) 1993 by Sun Microsystems, Inc. All rights reserved.
# 
#     Developed at SunPro, a Sun Microsystems, Inc. business.
#     Permission to use, copy, modify, and distribute this
#     software is freely granted, provided that this notice
#     is preserved.
# 
# It has been ported to work with uClibc and generally behave
# by Erik Andersen <andersen@codepoet.org>
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU Library General Public License as published by the Free
# Software Foundation; either version 2 of the License, or (at your option) any
# later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE. See the GNU Library General Public License for more
# details.
#
# You should have received a copy of the GNU Library General Public License
# along with this program; if not, write to the Free Software Foundation, Inc.,
# 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

TOPDIR=../
include $(TOPDIR)Rules.mak

ifeq ($(TARGET_ARCH),$(wildcard $(TARGET_ARCH)))
DIRS = $(TARGET_ARCH)
else
DIRS = 
endif
ALL_SUBDIRS = powerpc


LIBM=libm.a
LIBM_SHARED=libm.so
LIBM_SHARED_FULLNAME=libm-$(MAJOR_VERSION).$(MINOR_VERSION).so
CFLAGS+=-D_IEEE_LIBM -D_ISOC99_SOURCE -D_SVID_SOURCE

ifeq ($(strip $(DO_C99_MATH)),true)
CSRC =   e_acos.c e_acosh.c e_asin.c e_atan2.c e_atanh.c e_cosh.c\
         e_exp.c e_fmod.c e_gamma.c e_gamma_r.c e_hypot.c e_j0.c\
         e_j1.c e_jn.c e_lgamma.c e_lgamma_r.c e_log.c e_log10.c\
         e_pow.c e_remainder.c e_rem_pio2.c e_scalb.c e_sinh.c\
         e_sqrt.c k_cos.c k_rem_pio2.c k_sin.c k_standard.c k_tan.c\
         s_asinh.c s_atan.c s_cbrt.c s_ceil.c s_copysign.c s_cos.c\
         s_erf.c s_expm1.c s_fabs.c s_finite.c s_floor.c s_frexp.c\
         s_ilogb.c s_ldexp.c s_lib_version.c s_log1p.c s_logb.c\
         s_matherr.c s_modf.c s_nextafter.c s_rint.c s_scalbn.c\
         s_signgam.c s_significand.c s_sin.c s_tan.c s_tanh.c\
         w_acos.c w_acosh.c w_asin.c w_atan2.c w_atanh.c w_cabs.c\
         w_cosh.c w_drem.c w_exp.c w_fmod.c w_gamma.c w_gamma_r.c\
         w_hypot.c w_j0.c w_j1.c w_jn.c w_lgamma.c w_lgamma_r.c\
         w_log.c w_log10.c w_pow.c w_remainder.c w_scalb.c w_sinh.c\
         w_sqrt.c w_sqrtf.c fpmacros.c
else
# This list of math functions was taken from POSIX/IEEE 1003.1b-1993
CSRC =   w_acos.c w_asin.c s_atan.c w_atan2.c s_ceil.c s_cos.c \
	 w_cosh.c w_exp.c s_fabs.c s_floor.c w_fmod.c s_frexp.c \
	 s_ldexp.c w_log.c w_log10.c s_modf.c w_pow.c s_sin.c \
	 w_sinh.c w_sqrt.c s_tan.c s_tanh.c 
CSRC+=   s_expm1.c s_scalbn.c s_copysign.c e_acos.c e_asin.c e_atan2.c \
	 k_cos.c e_cosh.c e_exp.c e_fmod.c e_log.c e_log10.c e_pow.c \
	 k_sin.c e_sinh.c e_sqrt.c k_tan.c e_rem_pio2.c k_rem_pio2.c \
	 s_finite.c
endif
COBJS=$(patsubst %.c,%.o, $(CSRC))
OBJS=$(COBJS)


ifneq ($(strip $(HAS_FLOATING_POINT)),true)
all:  clean subdirs
else
all: $(OBJS) $(LIBM) subdirs
endif

$(LIBM): ar-target
	@if [ -f $(LIBM) ] ; then \
		set -x -e; \
		install -d $(TOPDIR)lib; \
		rm -f $(TOPDIR)lib/$(LIBM); \
		install -m 644 $(LIBM) $(TOPDIR)lib; \
	fi;

shared: all
	@if [ -f $(LIBM) ] ; then \
	    set -x -e; \
	    $(LD) $(LDFLAGS) -soname=$(LIBM_SHARED).$(MAJOR_VERSION) \
		-o $(LIBM_SHARED_FULLNAME) --whole-archive $(LIBM) \
		--no-whole-archive $(TOPDIR)/libc/misc/internals/interp.o \
		-L$(TOPDIR)/lib -lc; \
	    install -d $(TOPDIR)lib; \
	    rm -f $(TOPDIR)lib/$(LIBM_SHARED_FULLNAME) $(TOPDIR)lib/$(LIBM_SHARED).$(MAJOR_VERSION); \
	    install -m 644 $(LIBM_SHARED_FULLNAME) $(TOPDIR)lib; \
	    (cd $(TOPDIR)lib && ln -sf $(LIBM_SHARED_FULLNAME) $(LIBM_SHARED)); \
	    (cd $(TOPDIR)lib && ln -sf $(LIBM_SHARED_FULLNAME) $(LIBM_SHARED).$(MAJOR_VERSION)); \
	fi;

ar-target: $(OBJS)
	$(AR) $(ARFLAGS) $(LIBM) $(OBJS)

$(COBJS): %.o : %.c
	$(CC) $(CFLAGS) -c $< -o $@
	$(STRIPTOOL) -x -R .note -R .comment $*.o

$(OBJ): Makefile

tags:
	ctags -R

clean: subdirs_clean
	rm -f *.[oa] *~ core $(LIBM_SHARED)* $(LIBM_SHARED_FULLNAME)*

subdirs: $(patsubst %, _dir_%, $(DIRS))
subdirs_clean: $(patsubst %, _dirclean_%, $(ALL_SUBDIRS))

$(patsubst %, _dir_%, $(DIRS)) : dummy
	$(MAKE) -C $(patsubst _dir_%, %, $@)

$(patsubst %, _dirclean_%, $(ALL_SUBDIRS)) : dummy
	$(MAKE) -C $(patsubst _dirclean_%, %, $@) clean

.PHONY: dummy

=== libresolv/Makefile ===
# Makefile for uClibc
#
# Copyright (C) 2000 by Lineo, inc.
# Copyright (C) 2000,2001 Erik Andersen <andersen@uclibc.org>
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU Library General Public License as published by the Free
# Software Foundation; either version 2 of the License, or (at your option) any
# later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE. See the GNU Library General Public License for more
# details.
#
# You should have received a copy of the GNU Library General Public License
# along with this program; if not, write to the Free Software Foundation, Inc.,
# 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
# Derived in part from the Linux-8086 C library, the GNU C Library, and several
# other sundry sources.  Files within this library are copyright by their
# respective copyright holders.
# Makefile for uClibc

TOPDIR=../
include $(TOPDIR)Rules.mak

LIBRESOLV=libresolv.a
LIBRESOLV_SHARED=libresolv.so
LIBRESOLV_SHARED_FULLNAME=libresolv-$(MAJOR_VERSION).$(MINOR_VERSION).so

CSRC = resolv.c
OBJS=$(patsubst %.c,%.o, $(CSRC))

all: $(OBJS) $(LIBRESOLV)

$(LIBRESOLV): ar-target

ar-target: $(OBJS)
	$(AR) $(ARFLAGS) $(LIBRESOLV) $(OBJS)
	install -d $(TOPDIR)lib
	rm -f $(TOPDIR)lib/$(LIBRESOLV)
	install -m 644 $(LIBRESOLV) $(TOPDIR)lib

$(OBJS): %.o : %.c
	$(CC) $(CFLAGS) -c $< -o $@
	$(STRIPTOOL) -x -R .note -R .comment $*.o

$(OBJ): Makefile

shared: all
	$(LD) $(LDFLAGS) -soname=$(LIBRESOLV_SHARED).$(MAJOR_VERSION) \
		-o $(LIBRESOLV_SHARED_FULLNAME) --whole-archive $(LIBRESOLV) \
		--no-whole-archive $(TOPDIR)/libc/misc/internals/interp.o \
		-L$(TOPDIR)/lib -lc;
	install -d $(TOPDIR)lib
	rm -f $(TOPDIR)lib/$(LIBRESOLV_SHARED_FULLNAME) $(TOPDIR)lib/$(LIBRESOLV_SHARED).$(MAJOR_VERSION)
	install -m 644 $(LIBRESOLV_SHARED_FULLNAME) $(TOPDIR)lib;
	(cd $(TOPDIR)lib && ln -sf $(LIBRESOLV_SHARED_FULLNAME) $(LIBRESOLV_SHARED)); 
	(cd $(TOPDIR)lib && ln -sf $(LIBRESOLV_SHARED_FULLNAME) $(LIBRESOLV_SHARED).$(MAJOR_VERSION)); 

clean: 
	rm -f *.[oa] *~ core $(LIBRESOLV_SHARED)* $(LIBRESOLV_SHARED_FULLNAME)*

=== extra/gcc-uClibc/Makefile ===
# Makefile for building a fake gcc/binutils toolchain
# that simply spoofs the location of the C library
#
# Copyright (C) 2000,2001 Erik Andersen <andersen@uclibc.org>
#

TOPDIR = ../../
include $(TOPDIR)Rules.mak

UCLIBC_DIR = $(shell (cd ../.. ; /bin/pwd))
GCC_BIN = $(shell which $(CC))
LD_BIN = $(shell which $(LD))
GCC_LIB = $(shell $(CC) -print-libgcc-file-name )
GCC_LIB_DIR = $(dir $(shell $(CC) -print-libgcc-file-name ))
#GCCINCDIR inherited from Rules.mak

all: gcc-uClibc ld-uClibc

gcc-uClibc.h: $(TOPDIR)/Config
	@echo "/* this file was autogenerated by make */" > gcc-uClibc.h
	@echo "#define UCLIBC_TARGET_PREFIX " \"$(TARGET_PREFIX)\" >> gcc-uClibc.h
	@echo "#define UCLIBC_DEVEL_PREFIX " \"$(DEVEL_PREFIX)\" >> gcc-uClibc.h
	@echo "#define UCLIBC_BUILD_DIR " \"$(UCLIBC_DIR)\" >> gcc-uClibc.h
	@echo "#define GCC_BIN " \"$(GCC_BIN)\" >> gcc-uClibc.h
	@echo "#define GCC_LIB " \"$(GCC_LIB)\" >> gcc-uClibc.h
	@echo "#define GCC_LIB_DIR " \"$(GCC_LIB_DIR)\" >> gcc-uClibc.h
	@echo "#define GCC_INCDIR " \"$(GCCINCDIR)\" >> gcc-uClibc.h
	@echo "#define TARGET_ARCH " \"$(TARGET_ARCH)\" >> gcc-uClibc.h
	@echo "#define DYNAMIC_LINKER " \"$(DYNAMIC_LINKER)\" >> gcc-uClibc.h
	@echo "#define BUILD_DYNAMIC_LINKER " \"$(UCLIBC_DIR)/lib/$(UCLIBC_LDSO)\" >> gcc-uClibc.h

gcc-uClibc: gcc-uClibc.h gcc-uClibc.c
	gcc -Wall -O2 -s gcc-uClibc.c -o $(TARGET_ARCH)-uclibc-gcc

ld-uClibc:
	@echo "#!/bin/sh" > $(TARGET_ARCH)-uclibc-ld
	@echo "# This file was autogenerated by make" >> $(TARGET_ARCH)-uclibc-ld
	@echo "$(LD_BIN) \$$@ -L$(DEVEL_PREFIX)/usr/lib -L$(DEVEL_PREFIX)/lib "\
		"-L$(UCLIBC_DIR)" >> $(TARGET_ARCH)-uclibc-ld
	chmod a+x $(TARGET_ARCH)-uclibc-ld

install: all
	install -d $(PREFIX)$(DEVEL_PREFIX)/bin;
	install -d $(PREFIX)$(SYSTEM_DEVEL_PREFIX)/bin;
	install -m 755 $(TARGET_ARCH)-uclibc-gcc $(PREFIX)$(SYSTEM_DEVEL_PREFIX)/bin/
	install -m 755 $(TARGET_ARCH)-uclibc-ld $(PREFIX)$(SYSTEM_DEVEL_PREFIX)/bin/
	ln -fs $(TARGET_ARCH)-uclibc-gcc $(PREFIX)$(SYSTEM_DEVEL_PREFIX)/bin/$(TARGET_ARCH)-uclibc-g++
	ln -fs $(TARGET_ARCH)-uclibc-gcc $(PREFIX)$(SYSTEM_DEVEL_PREFIX)/bin/$(TARGET_ARCH)-uclibc-c++
	ln -fs $(TARGET_ARCH)-uclibc-gcc $(PREFIX)$(SYSTEM_DEVEL_PREFIX)/bin/$(TARGET_ARCH)-uclibc-cc
	ln -fs $(SYSTEM_DEVEL_PREFIX)/bin/$(TARGET_ARCH)-uclibc-gcc $(PREFIX)$(DEVEL_PREFIX)/bin/c++
	ln -fs $(SYSTEM_DEVEL_PREFIX)/bin/$(TARGET_ARCH)-uclibc-gcc $(PREFIX)$(DEVEL_PREFIX)/bin/g++
	ln -fs $(SYSTEM_DEVEL_PREFIX)/bin/$(TARGET_ARCH)-uclibc-gcc $(PREFIX)$(DEVEL_PREFIX)/bin/gcc
	ln -fs $(SYSTEM_DEVEL_PREFIX)/bin/$(TARGET_ARCH)-uclibc-gcc $(PREFIX)$(DEVEL_PREFIX)/bin/cc
	ln -fs $(SYSTEM_DEVEL_PREFIX)/bin/$(TARGET_ARCH)-uclibc-ld $(PREFIX)$(DEVEL_PREFIX)/bin/ld
	for app in addr2line ar as cpp gasp nm objcopy \
	    objdump ranlib size strings strip; do \
	  ln -fs `which $(CROSS)$${app}` $(PREFIX)$(DEVEL_PREFIX)/bin/$${app}; \
	  ln -fs `which $(CROSS)$${app}` $(PREFIX)$(SYSTEM_DEVEL_PREFIX)/bin/$(TARGET_ARCH)-uclibc-$${app}; \
	done

clean:
	rm -f gcc-uClibc.h *-uclibc-gcc *-uclibc-ld core

=== ldso/ldso/Makefile ===
# Makefile for uClibc
#
# Copyright (C) 2000 by Lineo, inc.
# Copyright (C) 2000,2001 Erik Andersen <andersen@uclibc.org>
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU Library General Public License as published by the Free
# Software Foundation; either version 2 of the License, or (at your option) any
# later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE. See the GNU Library General Public License for more
# details.
#
# You should have received a copy of the GNU Library General Public License
# along with this program; if not, write to the Free Software Foundation, Inc.,
# 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
# Derived in part from the Linux-8086 C library, the GNU C Library, and several
# other sundry sources.  Files within this library are copyright by their
# respective copyright holders.


TOPDIR=../../
DOPIC=true
include $(TOPDIR)Rules.mak
LDSO_FULLNAME=ld-uClibc-$(MAJOR_VERSION).$(MINOR_VERSION).so

# Enable this to enable all the code needed to support traditional ldd
# (i.e. where the shared library loader does all the heavy lifting)
# Since this currently only saves about 300 bytes, I'm going to leave 
# it enabled...
XXFLAGS+= -DDL_TRACE

# Enable this to enable debugging output from ld.so
#XXFLAGS+= -DDL_DEBUG
#XXFLAGS+= -DDL_DEBUG_SYMBOLS
#Enable this to never actually fixup symbols so you can watch each call...
#XXFLAGS+= -DDL_NEVER_FIXUP_SYMBOLS

XXFLAGS+=-DUCLIBC_TARGET_PREFIX=\"$(TARGET_PREFIX)\" \
	-DUCLIBC_DEVEL_PREFIX=\"$(DEVEL_PREFIX)\" \
	-DUCLIBC_BUILD_DIR=\"$(shell cd $(TOPDIR) && pwd)\"
LDFLAGS=-shared --warn-common --export-dynamic --sort-common \
	-z combreloc --discard-locals --discard-all
CSRC= ldso.c #hash.c readelflib1.c $(TARGET_ARCH)/elfinterp.c
COBJS=$(patsubst %.c,%.o, $(CSRC))
ASRC=$(shell ls $(TARGET_ARCH)/*.S)
AOBJS=$(patsubst %.S,%.o, $(ASRC))
OBJS=$(AOBJS) $(COBJS)

ifneq ($(strip $(DODEBUG)),true)
LDFLAGS+=-s
endif

all: lib

lib:: ldso.h $(OBJS) $(DLINK_OBJS)
	$(LD) $(LDFLAGS) -e _dl_boot -soname=$(UCLIBC_LDSO) \
		-o $(LDSO_FULLNAME) $(OBJS);
	install -d $(TOPDIR)lib 
	install -m 755 $(LDSO_FULLNAME) $(TOPDIR)lib
	(cd $(TOPDIR)lib && ln -sf $(LDSO_FULLNAME) $(UCLIBC_LDSO))

ldso.h: Makefile
	echo "const char *_dl_progname=\""$(UCLIBC_LDSO)"\";" > ldso.h
	echo "#include \"$(TARGET_ARCH)/elfinterp.c\"" >> ldso.h


$(COBJS): %.o : %.c
	$(CC) $(CFLAGS) $(XXFLAGS) -I. -I./$(TARGET_ARCH) -I../libdl -c $< -o $@
	$(STRIPTOOL) -x -R .note -R .comment $*.o

$(AOBJS): %.o : %.S
	$(CC) $(CFLAGS) -I. -I./$(TARGET_ARCH) -I../libdl -c $< -o $@
	$(STRIPTOOL) -x -R .note -R .comment $*.o

ldso.o: ldso.c hash.c readelflib1.c $(TARGET_ARCH)/elfinterp.c \
	ld_hash.h ld_string.h ld_syscall.h ldso.h linuxelf.h

clean::
	$(RM) -f $(UCLIBC_LDSO)* $(OBJS) $(LDSO_FULLNAME)* core *.o *.a *.s *.i ldso.h *~

=== ldso/util/Makefile ===
# Makefile for uClibc
#
# Copyright (C) 2000,2001 Erik Andersen <andersen@uclibc.org>
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU Library General Public License as published by the Free
# Software Foundation; either version 2 of the License, or (at your option) any
# later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE. See the GNU Library General Public License for more
# details.
#
# You should have received a copy of the GNU Library General Public License
# along with this program; if not, write to the Free Software Foundation, Inc.,
# 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
# Derived in part from the Linux-8086 C library, the GNU C Library, and several
# other sundry sources.  Files within this library are copyright by their
# respective copyright holders.

TOPDIR=../../
include $(TOPDIR)Rules.mak
TARGET_CC = $(TOPDIR)extra/gcc-uClibc/$(TARGET_ARCH)-uclibc-gcc

TARGETS=elf_header ldconfig ldd ldd.target readelf readelf.target
all: $(TARGETS)

elf_header:
	ln -fs $(TOPDIR)include/elf.h

readelf: readelf.c
	$(NATIVE_CC) $(NATIVE_CFLAGS) -I . readelf.c -o $@
	strip -x -R .note -R .comment $@

readelf.target: readelf.c
	$(TARGET_CC) $(CFLAGS) -static --uclibc-use-build-dir -s readelf.c -o $@
	$(STRIPTOOL) -x -R .note -R .comment $@

ifeq ($(strip $(LIBRARY_CACHE)),)
ldconfig: 
	echo "LIBRARY_CACHE disabled -- not building ldconfig"
else
readsoname.o: readsoname.c readsoname2.c
	$(NATIVE_CC) $(NATIVE_CFLAGS) -I . -c $< -o $@
	strip -x -R .note -R .comment $*.o
    
ldconfig.o: ldconfig.c
	$(NATIVE_CC) $(NATIVE_CFLAGS) -I . \
		-DUCLIBC_TARGET_PREFIX=\"$(TARGET_PREFIX)\" -c $< -o $@
	strip -x -R .note -R .comment $*.o

ldconfig: ldconfig.o readsoname.o
	$(NATIVE_CC) $(NATIVE_CFLAGS) $^ -o $@
	strip -x -R .note -R .comment $@
endif

ldd: ldd.c
	$(NATIVE_CC) $(NATIVE_CFLAGS) -DUCLIBC_TARGET_PREFIX=\"$(TARGET_PREFIX)\" \
		-DUCLIBC_DEVEL_PREFIX=\"$(DEVEL_PREFIX)\" \
		-DUCLIBC_BUILD_DIR=\"$(shell cd $(TOPDIR) && pwd)\" \
		-DUCLIBC_LDSO=\"$(UCLIBC_LDSO)\" -I . \
		ldd.c -o $@ 
	strip -x -R .note -R .comment $@

ldd.target: ldd.c
	$(TARGET_CC) $(CFLAGS) -static --uclibc-use-build-dir -s -DUCLIBC_TARGET_PREFIX=\"$(TARGET_PREFIX)\" \
		-DUCLIBC_DEVEL_PREFIX=\"$(DEVEL_PREFIX)\" \
		-DUCLIBC_BUILD_DIR=\"$(shell cd $(TOPDIR) && pwd)\" \
		-DUCLIBC_LDSO=\"$(UCLIBC_LDSO)\" \
		ldd.c -o $@
	$(STRIPTOOL) -x -R .note -R .comment $@

clean:
	rm -f $(TARGETS) *.o *~ core ./elf.h

=== libc/inet/Makefile ===
# Makefile for uClibc
#
# Copyright (C) 2000 by Lineo, inc.
# Copyright (C) 2000,2001 Erik Andersen <andersen@uclibc.org>
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU Library General Public License as published by the Free
# Software Foundation; either version 2 of the License, or (at your option) any
# later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE. See the GNU Library General Public License for more
# details.
#
# You should have received a copy of the GNU Library General Public License
# along with this program; if not, write to the Free Software Foundation, Inc.,
# 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
# Derived in part from the Linux-8086 C library, the GNU C Library, and several
# other sundry sources.  Files within this library are copyright by their
# respective copyright holders.

TOPDIR=../../
include $(TOPDIR)Rules.mak

ifeq ($(strip $(INCLUDE_RPC)),true)
	DIRS=rpc
else
	DIRS=
endif
ALL_SUBDIRS = rpc

MSRC=addr.c
MOBJ=inet_aton.o inet_addr.o inet_ntoa.o inet_makeaddr.o inet_lnaof.o \
	inet_netof.o

MSRC2=resolv.c
MOBJ2=encodeh.o decodeh.o encoded.o decoded.o lengthd.o encodeq.o \
	decodeq.o lengthq.o encodea.o decodea.o encodep.o decodep.o \
	formquery.o dnslookup.o resolveaddress.o resolvemailbox.o \
	opennameservers.o closenameservers.o resolvename.o gethostbyname.o\
	res_init.o res_query.o gethostbyaddr.o \
	read_etc_hosts_r.o get_hosts_byname_r.o get_hosts_byaddr_r.o \
	gethostbyname2.o getnameinfo.o gethostent.o sethostent.o endhostent.o \
	gethostbyname_r.o gethostbyname2_r.o gethostbyaddr_r.o

MSRC3=socketcalls.c
MOBJ3= accept.o bind.o connect.o getpeername.o getsockname.o getsockopt.o \
	listen.o recv.o recvfrom.o recvmsg.o send.o sendmsg.o sendto.o \
	setsockopt.o shutdown.o socket.o socketpair.o 

CSRC =getservice.c getproto.c hostid.c getnetent.c getnetbynm.c getnetbyad.c \
	inet_net.c ntop.c herror.c if_nametoindex.c gai_strerror.c getaddrinfo.c 

COBJS=$(patsubst %.c,%.o, $(CSRC))

OBJS=$(MOBJ) $(MOBJ2) $(MOBJ3) $(COBJS)


all: $(OBJS) $(LIBC)

$(LIBC): ar-target subdirs

ar-target: $(OBJS)
	$(AR) $(ARFLAGS) $(LIBC) $(OBJS)

$(MOBJ): $(MSRC)
	$(CC) $(CFLAGS) -DL_$* $< -c -o $*.o
	$(STRIPTOOL) -x -R .note -R .comment $*.o

$(MOBJ2): $(MSRC2)
	$(CC) $(CFLAGS) -DL_$* $< -c -o $*.o
	$(STRIPTOOL) -x -R .note -R .comment $*.o

$(MOBJ3): $(MSRC3)
	$(CC) $(CFLAGS) -DL_$* $< -c -o $*.o
	$(STRIPTOOL) -x -R .note -R .comment $*.o

$(COBJS): %.o : %.c
	$(CC) $(CFLAGS) -c $< -o $@
	$(STRIPTOOL) -x -R .note -R .comment $*.o

clean: subdirs_clean
	rm -f *.[oa] *~ core

subdirs: $(patsubst %, _dir_%, $(DIRS))
subdirs_clean: $(patsubst %, _dirclean_%, $(ALL_SUBDIRS))

$(patsubst %, _dir_%, $(DIRS)) : dummy
	$(MAKE) -C $(patsubst _dir_%, %, $@)

$(patsubst %, _dirclean_%, $(ALL_SUBDIRS)) : dummy
	$(MAKE) -C $(patsubst _dirclean_%, %, $@) clean

.PHONY: dummy

=== libc/misc/Makefile ===
# Makefile for uClibc
#
# Copyright (C) 2000 by Lineo, inc.
# Copyright (C) 2000,2001 Erik Andersen <andersen@uclibc.org>
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU Library General Public License as published by the Free
# Software Foundation; either version 2 of the License, or (at your option) any
# later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE. See the GNU Library General Public License for more
# details.
#
# You should have received a copy of the GNU Library General Public License
# along with this program; if not, write to the Free Software Foundation, Inc.,
# 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
# Derived in part from the Linux-8086 C library, the GNU C Library, and several
# other sundry sources.  Files within this library are copyright by their
# respective copyright holders.

TOPDIR=../../
include $(TOPDIR)Rules.mak


DIRS = assert ctype dirent file fnmatch glob internals lsearch \
       mntent syslog time utmp tsearch locale sysvipc statfs \
       error insremque ttyent
ifeq ($(strip $(INCLUDE_REGEX)),true)
DIRS += regex
endif
ifeq ($(strip $(INCLUDE_THREADS)),true)
DIRS += pthread
endif

all: libc.a

libc.a: subdirs

tags:
	ctags -R

clean: subdirs_clean
	rm -f *.[oa] *~ core

subdirs: $(patsubst %, _dir_%, $(DIRS))
subdirs_clean: $(patsubst %, _dirclean_%, $(DIRS))

$(patsubst %, _dir_%, $(DIRS)) : dummy
	$(MAKE) -C $(patsubst _dir_%, %, $@)

$(patsubst %, _dirclean_%, $(DIRS)) : dummy
	$(MAKE) -C $(patsubst _dirclean_%, %, $@) clean

.PHONY: dummy

=== libc/pwd_grp/Makefile ===
# Makefile for uClibc
#
# Copyright (C) 2000 by Lineo, inc.
# Copyright (C) 2000,2001 Erik Andersen <andersen@uclibc.org>
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU Library General Public License as published by the Free
# Software Foundation; either version 2 of the License, or (at your option) any
# later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE. See the GNU Library General Public License for more
# details.
#
# You should have received a copy of the GNU Library General Public License
# along with this program; if not, write to the Free Software Foundation, Inc.,
# 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
# Derived in part from the Linux-8086 C library, the GNU C Library, and several
# other sundry sources.  Files within this library are copyright by their
# respective copyright holders.

TOPDIR=../../
include $(TOPDIR)Rules.mak

CSRC= pwent.c getpwnam.c getpwuid.c putpwent.c getpw.c fgetpwent.c \
	__getgrent.c grent.c getgrnam.c getgrgid.c fgetgrent.c \
	initgroups.c __getpwent_r.c

ifeq ($(HAS_SHADOW),true)
CSRC+= lckpwdf.c spent.c getspnam.c getspuid.c putspent.c sgetspent.c \
	fgetspent.c __getspent_r.c __sgetspent_r.c
endif

COBJS=$(patsubst %.c,%.o, $(CSRC))
OBJS=$(COBJS)

all: $(OBJS) $(LIBC)

$(LIBC): ar-target

ar-target: $(OBJS)
	$(AR) $(ARFLAGS) $(LIBC) $(OBJS)

$(COBJS): %.o : %.c
	$(CC) $(CFLAGS) -c $< -o $@
	$(STRIPTOOL) -x -R .note -R .comment $*.o

$(OBJ): Makefile

__getgrent.c: config.h
initgroups.c: config.h

clean:
	rm -f *.[oa] *~ core

=== libc/signal/Makefile ===
# Makefile for uClibc
#
# Copyright (C) 2000 by Lineo, inc.
# Copyright (C) 2000,2001 Erik Andersen <andersen@uclibc.org>
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU Library General Public License as published by the Free
# Software Foundation; either version 2 of the License, or (at your option) any
# later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE. See the GNU Library General Public License for more
# details.
#
# You should have received a copy of the GNU Library General Public License
# along with this program; if not, write to the Free Software Foundation, Inc.,
# 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
# Derived in part from the Linux-8086 C library, the GNU C Library, and several
# other sundry sources.  Files within this library are copyright by their
# respective copyright holders.

TOPDIR=../../
include $(TOPDIR)Rules.mak

CSRC= allocrtsig.c killpg.c raise.c sigaction.c sigaddset.c sigandset.c \
	sigblock.c sigdelset.c sigempty.c sigfillset.c siggetmask.c sighold.c \
	sigignore.c sigintr.c sigisempty.c sigismem.c sigjmp.c signal.c \
	sigorset.c sigpause.c sigrelse.c sigset.c sigsetmask.c sigsetops.c \
	sysv_signal.c
COBJS=$(patsubst %.c,%.o, $(CSRC))

OBJS=$(COBJS)

all: $(OBJS) $(LIBC)

$(LIBC): ar-target

ar-target: $(OBJS)
	$(AR) $(ARFLAGS) $(LIBC) $(OBJS)

$(COBJS): %.o : %.c
	$(CC) $(CFLAGS) -c $< -o $@
	$(STRIPTOOL) -x -R .note -R .comment $*.o

clean:
	rm -f *.[oa] *~ core

=== debian/changelog ===
uclibc (0.9.10-cvs20020406-1) unstable; urgency=low

  * new upstream snapshot
    - should fix build on mips
  * updated shlibs to 0.9.10, since it was broken previously (actually
    was done in previous upload)
  * create top-level lib/, for safety

 -- David Schleef <ds@schleef.org>  Sat,  6 Apr 2002 14:34:41 -0800

uclibc (0.9.10-1) unstable; urgency=low

  * New upstream release (Closes: #140295)

 -- David Schleef <ds@schleef.org>  Thu, 28 Mar 2002 11:25:17 -0800

uclibc (0.9.9-cvs20020221-2) unstable; urgency=low

  * debian/rules: touch linux/autoconf.h.  Should make us buildable
    on arm.
  * add build-dep on bzip2

 -- David Schleef <ds@schleef.org>  Sun, 24 Feb 2002 17:26:37 -0800

uclibc (0.9.9-cvs20020221-1) unstable; urgency=low

  * New upstream snapshot
  * Add subarchitecture symlinks on arm
  * Use mips config file on mipsel

 -- David Schleef <ds@schleef.org>  Thu, 21 Feb 2002 23:11:23 -0800

uclibc (0.9.9-cvs20020210-1) unstable; urgency=low

  * New upstream snapshot.
  * debian/mksnapshot: updated version and filenames
  * debian/control.in: changed dependency from kernel-headers to
      kernel-source.
  * debian/rules: force HAS_MMU=true
  * debian/rules: change mipsel to mips
  * debian/rules: untar kernel-source include directory and use
      that as kernel source.
  * Previous 3 lines should fix autobuildability (Closes: #131373)

 -- David Schleef <ds@schleef.org>  Sun, 10 Feb 2002 17:11:22 -0800

uclibc (0.9.5-cvs20011117-1) unstable; urgency=low

  * New upstream snaphot
  * mksnapshot (new): script to generate snapshots from upstream CVS
  * control, control.in: limited architectures to those that can
      theoretically build.  Updated kernel-headers dependency to
      -2.4.10 -- this may cause problems with autobuilders.
  * fixlinks (new): script to fix up symlinks to comply with policy.
      Decreases number of lintian complaints.
  * rules: use fixlinks.  Fix method of finding kernel headers --
      should increase potential autobuildability.
  * uclibc-ldd.1, uclibc-readelf.1: Bogus updates to bogus man pages.
      These really need to be written.

 -- David Schleef <ds@schleef.org>  Sat, 17 Nov 2001 18:10:33 -0800

uclibc (0.9.5-cvs20011011-1) unstable; urgency=low

  * Closes #104243

 -- David Schleef <ds@schleef.org>  Thu, 11 Oct 2001 13:29:02 -0700

uclibc (0.9.5-cvs20010702-1) unstable; urgency=low

  * Build from CVS
  * Can create cross-compiling library (but not cross packages)

 -- David Schleef <ds@schleef.org>  Mon,  2 Jul 2001 23:16:20 -0700

uclibc (0.9.5-cvs20010630-1) unstable; urgency=low

  * No, really.  Initial Release.  I mean it this time.
  * Clean up patch.

 -- David Schleef <ds@schleef.org>  Sat, 30 Jun 2001 17:12:41 -0700

uclibc (0.9.5-cvs20010626-1) unstable; urgency=low

  * No, really.  Initial Release.

 -- David Schleef <ds@schleef.org>  Thu, 28 Jun 2001 16:49:25 -0700

uclibc (0.9.5-cvs20010625-1) unstable; urgency=low

  * Initial Release.

 -- David Schleef <ds@schleef.org>  Mon, 25 Jun 2001 22:13:43 -0700

=== debian/control ===
Source: uclibc
Section: devel
Priority: optional
Maintainer: David Schleef <ds@schleef.org>
Build-Depends: debhelper, bzip2, kernel-source-2.4.16
Standards-Version: 3.5.6

Package: libuclibc-dev
Section: devel
Architecture: arm i386 m68k mips mipsel powerpc sh sparc
Depends: libuclibc0 (= ${Source-Version})
Description: A small implementation of the C library
 uClibc is an implementation of the standard C library that is
 much smaller than glibc, which makes it useful for embedded
 systems.  This package includes header files and development
 libraries necessary to compile applications that use uClibc.

Package: libuclibc0
Section: libs
Architecture: arm i386 m68k mips mipsel powerpc sh sparc
Depends:
Description: A small implementation of the C library
 uClibc is an implementation of the standard C library that is
 much smaller than glibc, which makes it useful for embedded
 systems.  This package provides only the run-time libraries.
 .
 The Debian binary packages for uClibc do not provide the necessary
 components for using uClibc as the primary library on a system,
 as might be done for an embedded system.

Package: uclibc-toolchain
Section: devel
Architecture: arm i386 m68k mips mipsel powerpc sh sparc
Depends: gcc|c-compiler, binutils, ${shlibs:Depends}
Recommends: libuclibc-dev
Conflicts: uclibc-gcc
Replaces: uclibc-gcc
Description: A compiler wrapper for uClibc
 This package includes utilities that function as a toolchain for
 compiling with uClibc instead of the native libc.  The utilities
 have names such as powerpc-uclibc-gcc (depending on the architecture),
 and should behave identically to the base utilities, except that
 they use headers and libraries provided in the libuclibc-dev
 package.  Most utilities are symbolic links to the correct underlying
 utility, although gcc and ld are implemented as wrapper binaries that
 call gcc and ld with the necessary arguments and command line options.

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 to 1999 by Joey Hess.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This is the debhelper compatability version to use.
export DH_COMPAT=1

#include version
major=$(shell grep '^MAJOR_VERSION' Rules.mak|sed 's/.*=//')
minor=$(shell grep '^MINOR_VERSION' Rules.mak|sed 's/.*=//')
version:=$(strip $(major)).$(strip $(minor))

kernel_source=kernel-source-2.4.16

target=$(DEB_HOST_GNU_CPU)
#target=arm

with_shared_libs=y
#ifeq ($(target),powerpc)
#with_shared_libs=n
#endif

ifneq ($(target),$(DEB_HOST_GNU_CPU))
target_suffix=-$(target)
endif

p_dev=libuclibc-dev$(target_suffix)
p_lib=libuclibc0$(target_suffix)
p_gcc=uclibc$(target_suffix)-toolchain

debian/control: debian/control.in debian/rules
	sed -e s/_TARGET_/$(target_suffix)/ \
	  -e "s/_ARCHS_/arm i386 m68k mips mipsel powerpc sh sparc/" \
	  -e "s/_KERNEL_/$(kernel_source)/" \
	  debian/control.in >debian/control

build: build-stamp
build-stamp: debian/control
	dh_testdir

	# Brute force method of getting kernel headers
	tar --bzip2 -xf /usr/src/$(kernel_source).tar.bz2 \
	  $(kernel_source)/include

	# Hack to get include/asm-arm/arch directory.  This should
	# stay here, and not move to the top-level Makefile, since
	# it adds a link _in the kernel source_, which is almost
	# certainly wrong in most situations.
#ifeq ($(target),arm)
	ln -s arch-sa1100 $(kernel_source)/include/asm-arm/arch
	ln -s proc-armo $(kernel_source)/include/asm-arm/proc
#endif
	
	touch $(kernel_source)/include/linux/autoconf.h

ifneq ($(target),mipsel)
	cp extra/Configs/Config.$(target) Config
else
	cp extra/Configs/Config.mips Config
endif

	echo '#Debian configuration overrides'  >>Config
ifneq ($(target),$(DEB_HOST_GNU_CPU))
	echo 'TARGET_ARCH = $(target)'  >>Config
	echo 'CROSS = $(target)-linux-'  >>Config
else
	echo 'CROSS = '  >>Config
endif
	echo 'DOPIC = true'  >>Config
	echo 'SYSTEM_DEVEL_PREFIX = /usr'  >>Config
	echo 'DEVEL_PREFIX = /usr/$$(TARGET_ARCH)-linux-uclibc'  >>Config
	echo 'SHARED_LIB_LOADER_PATH = /lib'  >>Config
	#echo 'TARGET_PREFIX = /'  >>Config
ifeq ($(with_shared_libs),n)
	echo 'HAVE_SHARED = false' >>Config
else
	echo 'HAVE_SHARED = true' >>Config
endif
	echo 'KERNEL_SOURCE = '`pwd`/$(kernel_source) >>Config
	echo 'HAS_MMU = true' >>Config
	echo 'HAS_FLOATING_POINT = true' >>Config
	echo 'DO_C99_MATH = true' >>Config
	echo 'DODEBUG = false' >>Config
	echo 'INCLUDE_THREADS = true' >>Config

	mkdir -p lib

	$(MAKE)

	touch build-stamp

clean: debian/control
	dh_testdir
	dh_testroot
	rm -f build-stamp

	rm -f debian/$(p_dev)

	rm -rf kernel-source-*

	# Add here commands to clean up after the build process.
	-$(MAKE) clean

	-rm Config

	dh_clean

install: build debian/control
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs

	-rm debian/$(p_dev)
	ln -s tmp debian/$(p_dev)

	# Add here commands to install the package into debian/tmp.
	$(MAKE) install_dev PREFIX=`pwd`/debian/$(p_dev)
	$(MAKE) install_runtime PREFIX=`pwd`/debian/$(p_lib)
	$(MAKE) install_toolchain PREFIX=`pwd`/debian/$(p_gcc)
	$(MAKE) install_utils PREFIX=`pwd`/debian/$(p_gcc)

	install -d debian/$(p_gcc)/usr/share/man/man1
	install -m 644 debian/uclibc-gcc.1 \
	  debian/$(p_gcc)/usr/share/man/man1/$(target)-uclibc-gcc.1
	(cd debian/$(p_gcc)/usr/share/man/man1; \
	  ln -sf $(target)-uclibc-gcc.1.gz $(target)-uclibc-cc.1.gz; \
	  ln -sf $(target)-uclibc-gcc.1.gz $(target)-uclibc-ld.1.gz; \
	  for x in addr2line ar as cpp gasp nm objcopy objdump ranlib \
	  size strings strip;do \
	    ln -sf $$x.1.gz $(target)-uclibc-$$x.1.gz;done)
	
	install -d debian/$(p_lib)/usr/share/man/man1
	install -m 644 debian/uclibc-ldd.1 \
	  debian/$(p_lib)/usr/share/man/man1/$(target)-uclibc-ldd.1
	install -m 644 debian/uclibc-ldconfig.1 \
	  debian/$(p_lib)/usr/share/man/man1/$(target)-uclibc-ldconfig.1
	install -m 644 debian/uclibc-readelf.1 \
	  debian/$(p_lib)/usr/share/man/man1/$(target)-uclibc-readelf.1

	(cd debian/$(p_dev); find . -name '.*' -exec rm -f '{}' ';')
	(cd debian/$(p_lib); find . -name '.*' -exec rm -f '{}' ';')
	(cd debian/$(p_gcc); find . -name '.*' -exec rm -f '{}' ';')

ifeq ($(with_shared_libs),y)
ifeq ($(target),$(DEB_HOST_GNU_CPU))
	mkdir -p debian/$(p_lib)/lib/
	ln -sf /usr/$(target)-linux-uclibc/lib/ld-uClibc.so.0 \
	  debian/$(p_lib)/lib/ld-uClibc.so.0
endif
endif

# Build architecture-independent files here.
binary-indep:

# Build architecture-dependent files here.
binary-arch: build install
#	dh_testversion
	dh_testdir
	dh_testroot

#	dh_installdebconf	
	dh_installdocs
	dh_installexamples
	dh_installmenu
#	dh_installemacsen
#	dh_installpam
#	dh_installinit
	dh_installcron
#	dh_installmanpages -plibuclibc0
	dh_installinfo
#	dh_undocumented
	dh_installchangelogs 
	dh_link
	cd debian/libuclibc0 && ../fixlinks
	cd debian/libuclibc-dev && ../fixlinks
	cd debian/uclibc-toolchain && ../fixlinks
	dh_strip
	dh_compress
	dh_fixperms -Xld-uClibc
	# You may want to make some executables suid here.
#	dh_suidregister
#	dh_makeshlibs
	dh_installdeb
#	dh_perl
ifeq ($(target),$(DEB_HOST_GNU_CPU))
	dh_shlibdeps --exclude=ld_uclibc -ldebian/$(p_lib)/usr/$(target)-linux-uclibc/lib
else
	dh_shlibdeps --exclude=lib
endif
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install
